package com.cf.imes.module.system.service.lable;

import com.cf.imes.framework.common.pojo.PageResult;
import com.cf.imes.module.system.controller.admin.label.vo.LabelPageReqVO;
import com.cf.imes.module.system.controller.admin.label.vo.LabelRespVO;
import com.cf.imes.module.system.controller.admin.label.vo.LabelSaveReqVO;
import com.cf.imes.module.system.dal.dataobject.lable.LabelDO;

import javax.validation.Valid;
import java.util.List;
import java.util.Map;

/**
 * 标签模板 Service 接口
 *
 * @author 晨丰科技
 */
public interface LabelService {

    /**
     * 创建标签模板
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createLabel(@Valid LabelSaveReqVO createReqVO);

    /**
     * 更新标签模板
     *
     * @param updateReqVO 更新信息
     */
    void updateLabel(@Valid LabelSaveReqVO updateReqVO);

    /**
     * 删除标签模板
     *
     * @param id 编号
     */
    void deleteLabel(Long id);

    /**
     * 获得标签模板
     *
     * @param id 编号
     * @return 标签模板
     */
    LabelRespVO getLabel(Long id);

    /**
     * 获得标签模板分页
     *
     * @param pageReqVO 分页查询
     * @return 标签模板分页
     */
    PageResult<LabelDO> getLabelPage(LabelPageReqVO pageReqVO);


    Map<String, List<LabelRespVO>> getGroupList(Long organId);

    List<LabelDO> list(String type);
}